package de.jugmuenster.sevendemo.coin;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;

/**
 * Java 7 Demo: Diamond Operator
 * 
 * - java.lang.AutoCloseable
 * - JDBC 4.1, Files
 * - Exceptions stored with Throwable.addSuppressed
 * - Exceptions retrieved with Throwable.getSuppressed
 */
public class TryResources
{
    public static void main(String[] args)
    {
        try (InputStreamReader is = new InputStreamReader(Thread.currentThread().getContextClassLoader().getResourceAsStream("sample"));
                BufferedReader br = new BufferedReader(is);)
        {
            System.out.println(br.readLine());
        }
        //look! no close or finally
        catch(IOException ex)
        {
            Throwable[] s = ex.getSuppressed();
            if (s != null)
            {
                 //...
            }
        }
    }
}
