package de.jugmuenster.sevendemo.forkjoin;

import java.util.concurrent.ForkJoinPool;


public class ForkJoinFibonacci
{
    public static void main(String[] args)
    {
        int problemSize = 48;
        int processors = Runtime.getRuntime().availableProcessors();
        System.out.println(String.format("Number of processors: %d", processors));


        FibonacciJob job = new FibonacciJob(problemSize);

        FibonacciTask task = new FibonacciTask(job);
        ForkJoinPool pool = new ForkJoinPool(processors);
        
        long start = System.currentTimeMillis();
        
        pool.invoke(task);

        long result = task.result;
        long end = System.currentTimeMillis();
        System.out.println(String.format("Computed result with fork-join: %d in %d ms", result, end-start));
        
        start = System.currentTimeMillis();
        job.solve();
        end = System.currentTimeMillis();
        System.out.println(String.format("Computed result: %d in %d ms", result, end-start));
    }
}
